      PROGRAM Bi Tra
C Binarno pretrazivanje niza brojeva
      INTEGER   d, s, g
      PARAMETER (maxA = 100, maxC = 30)
      DIMENSION A(maxA), C(maxC)
      LOGICAL ima
    1 FORMAT (1X, A, $)
    2 FORMAT (10F8.0)
    3 FORMAT (/ 1X, '      b   ima' / 14('='))
    4 FORMAT (1X, F10.3, L3)
C     Citanje podataka
      PRINT 1, 'Duzina uredjenog niza? '
      READ  *, n
      IF (n.le.0 .or. n.gt.maxA) STOP '*** Nedozvoljena du`ina niza ***'
      PRINT 1, 'Elementi uredjenog niza? '
      READ 2, (A(i), i=1,n)
      PRINT 1, 'Duzina neuredjenog niza? '
      READ  *, m
      IF (m.le.0 .or. m.gt.maxC) STOP '*** Nedozvoljena du`ina niza ***'
      PRINT 1, 'Elementi neuredjenog niza? '
      READ 2, (C(i), i=1,m)
C     Zaglavlje izvestaja
      PRINT 3
C     Obrada pojedinih brojeva neuredjenog niza
      DO k = 1, m
        b = C(k)
C       Pretrazivanje uredjenog niza
        d   = 1
        g   = n
        ima = .false.
        DO WHILE (d.le.g .and. .not.ima)
          s = (d + g) / 2
          IF      (A(s) .lt. b) THEN
            d = s + 1
          ELSE IF (A(s) .gt. b) THEN
            g = s - 1
          ELSE
            ima = .true.
          END IF
        END DO
C       Ispisivanje rezultata
        PRINT 4, b, ima
      END DO
      END
