      SUBROUTINE Gauss (A, B, nmax, n, X)
C Resavanje sistema linearnih jednacina Gauss-ovom metodom eliminacije
      DIMENSION A(nmax,nmax), B(nmax), X(nmax)
C     Eliminacija unapred
      DO i = 1, n-1
        DO j = i+1, n
          c = A(j,i) / A(i,i)
          B(j) = B(j) - B(i) * c
          DO k = n, i, -1
            A(j,k) = A(j,k) - A(i,k) * c
          END DO
        END DO
      END DO
C     Zamene unazad
      DO j = n, 1, -1
        s = 0
        DO k = j+1, n
          s = s + A(j,k) * X(k)
        END DO
        X(j) = (B(j) - s) / A(j,j)
      END DO
      END
