/* Izracunavanje Lagranzovog polinoma */

float p (float xx[], float yy[], int n, float x) {
  int i, j;  float s, r;
  for (s=i=0; i<n; i++) {
    for (r=1, j=0; j<n; j++)
      if (j != i)
        r *= (x-xx[j]) / (xx[i]-xx[j]);
    s += yy[i] * r;
  }
  return s;
}

/* Tabeliranje polinoma */

#include <stdio.h>

main () {
  int n, i;  float xx[50], yy[50], x, xmin, xmax, dx;
  printf ("n? "); scanf ("%d", &n);
  for (i=0; i<n; i++) {
    printf ("x[%d], y[%d]? ", i, i); scanf ("%f%f", &xx[i], &yy[i]);
  }
  printf ("xmin, xmax, dx? "); scanf ("%f%f%f", &xmin, &xmax, &dx);
  printf ("\n         x        p(x)\n"
            "======================\n");
  for (x=xmin; x<=xmax; x+=dx)
    printf ("%10.2f  %10.2f\n", x, p(xx,yy,n,x));
}
