#include <stdio.h>

/* Nalazenje kolicnika dva polinoma (P1 = P2 * P3 + P4) */

void pdeli (float p1[], int  n1, float p2[], int n2,
            float p3[], int *m3, float p4[], int *m4) {
  int n3=n1-n2, n4, i, j;
  for (i=0; i<=n1; i++) p4[i] = p1[i];
  for (i=n3; i>=0; i--) {
    p3[i] = p4[n2+i] / p2[n2];
    for (j=0; j<=n2; j++) p4[j+i] -= p2[j] * p3[i];
  }
  for (n4=n2; n4>=0 && p4[n4]==0; n4--) ;
  *m3 = n3; *m4 = n4;
}

/* Ispitivanje potprograma "pdeli" */

main () {
  float p1[21], p2[21], p3[21], p4[21];
  int n1, n2, n3, n4, i;
  while (printf("n1,n2? "),scanf("%d%d",&n1,&n2), n1>=0 && n2>=0) {
    printf ("P1?    "); for (i=n1; i>=0; scanf("%f", &p1[i--]));
    printf ("P2?    "); for (i=n2; i>=0; scanf("%f", &p2[i--]));
    pdeli (p1, n1, p2, n2, p3, &n3, p4, &n4);
    printf ("P1*P2= "); for (i=n3; i>=0; printf ("%.2f ", p3[i--]));
    printf ("\n");
    printf ("P1%P2= "); for (i=n4; i>=0; printf ("%.2f ", p4[i--]));
    printf ("\n\n");
  }
}
