      SUBROUTINE Minim (Fun, x1, x2, n, eps, xmin, ymin)
C Nalazenje minimuma funkcije metodom deljenja intervala
      xa   = x1
      xb   = x2
      dx   = (xb - xa) / n
      xmin = xa
      ymin = Fun (xmin)
      DO WHILE (abs(dx) .gt. max(eps*abs(xmin),eps))
        DO i = 0, n
          x = xa + i * dx
          y = Fun (x)
          IF (y .lt. ymin) THEN
            xmin = x
            ymin = y
          END IF
        END DO
        xa = xmin - dx
        xb = xmin + dx
        dx = (xb - xa) / n
      END DO
      END
